// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QGEOCODINGMANAGERWRAPPER_H
#define SBK_QGEOCODINGMANAGERWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtLocation/qgeocodingmanager.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QGeoCodingManagerWrapper : public QGeoCodingManager
{
public:
    QGeoCodingManagerWrapper(const QGeoCodingManagerWrapper &) = delete;
    QGeoCodingManagerWrapper& operator=(const QGeoCodingManagerWrapper &) = delete;
    QGeoCodingManagerWrapper(QGeoCodingManagerWrapper &&) = delete;
    QGeoCodingManagerWrapper& operator=(QGeoCodingManagerWrapper &&) = delete;

    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    const ::QMetaObject * metaObject() const override;
    void timerEvent(::QTimerEvent * event) override;
    ~QGeoCodingManagerWrapper() override;
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[7];
};

#endif // SBK_QGEOCODINGMANAGERWRAPPER_H

