// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QPLACEDETAILSREPLYWRAPPER_H
#define SBK_QPLACEDETAILSREPLYWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtLocation/qplacedetailsreply.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QPlaceDetailsReplyWrapper : public QPlaceDetailsReply
{
public:
    QPlaceDetailsReplyWrapper(const QPlaceDetailsReplyWrapper &) = delete;
    QPlaceDetailsReplyWrapper& operator=(const QPlaceDetailsReplyWrapper &) = delete;
    QPlaceDetailsReplyWrapper(QPlaceDetailsReplyWrapper &&) = delete;
    QPlaceDetailsReplyWrapper& operator=(QPlaceDetailsReplyWrapper &&) = delete;

    QPlaceDetailsReplyWrapper(::QObject * parent = nullptr);
    void abort() override;
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    const ::QMetaObject * metaObject() const override;
    void timerEvent(::QTimerEvent * event) override;
    ::QPlaceReply::Type type() const override;
    ~QPlaceDetailsReplyWrapper() override;
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[9];
};

#endif // SBK_QPLACEDETAILSREPLYWRAPPER_H

